DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Member Functions | Private Attributes | List of all members
DVPSReferencedSeries_PList Class Reference

the list of referenced series contained in a presentation state (internal use only). More...

## Public Member Functions
| DVPSReferencedSeries_PList ()
| default constructor
| DVPSReferencedSeries_PList (const DVPSReferencedSeries_PList &copy)
| copy constructor
DVPSReferencedSeries_PList * | clone ()
| clone method. More...
virtual | ~DVPSReferencedSeries_PList ()
| destructor
OFCondition | read (DcmItem &dset)
| reads a list of series references (ReferencedSeriesSequence) from a DICOM dataset. More...
OFCondition | write (DcmItem &dset)
| writes the list of series references managed by this object to a DICOM dataset. More...
void | clear ()
| reset the object to initial state. More...
OFBool | isValid ()
| checks whether at least one series is referenced, whether all referenced series contain image references and whether all references images use the same SOP class.
OFBool | checkSOPClass (const char *uid)
| checks whether all images referenced in this series use the passed SOP class UID. More...
DVPSReferencedSeries * | findSeriesReference (const char *seriesUID)
| find series reference in this list. More...
DVPSReferencedImage * | findImageReference (const char *seriesUID, const char *instanceUID)
| find image reference in this list. More...
void | removeSeriesReference (const char *seriesUID)
| removes series reference. More...
void | removeImageReference (const char *seriesUID, const char *instanceUID)
| removes image reference. More...
OFCondition | addImageReference (const char *seriesUID, const char *sopclassUID, const char *instanceUID, const char *frames=NULL, const char *aetitle=NULL, const char *filesetID=NULL, const char *filesetUID=NULL)
| add new image reference. More...
size_t | numberOfImageReferences ()
| gets the number of image references in all series managed by this list. More...
OFCondition | getImageReference (size_t idx, OFString &seriesUID, OFString &sopclassUID, OFString &instanceUID, OFString &frames, OFString &aetitle, OFString &filesetID, OFString &filesetUID)
| gets an image reference with the given index. More...

## Private Member Functions
DVPSReferencedSeries_PList & | operator= (const DVPSReferencedSeries_PList &)
| private undefined assignment operator

## Private Attributes
OFList< DVPSReferencedSeries * > | list_
| the list maintained by this object

## Detailed Description

the list of referenced series contained in a presentation state (internal use only).

This class manages the data structures comprising the complete Referenced Series Sequence in a Presentation State object.

## Member Function Documentation

## ◆ addImageReference()

OFCondition DVPSReferencedSeries_PList::addImageReference | ( | const char * | seriesUID,
|  | const char * | sopclassUID,
|  | const char * | instanceUID,
|  | const char * | frames = `NULL`,
|  | const char * | aetitle = `NULL`,
|  | const char * | filesetID = `NULL`,
|  | const char * | filesetUID = `NULL`
| ) |  |

add new image reference.

This method checks if the given SOP class matches the SOP class of all other existing image references and whether the image reference exists. In this case an error code is returned. Otherwise a new image reference (in a new series if necessary) is created.

Parameters

  seriesUID | the Series Instance UID of the image reference to be added.
  sopclassUID | the SOP class UID of the image reference to be added.
  instanceUID | the SOP instance UID of the image reference to be added.
  frames | a list of frame numbers in DICOM IS format (integer numbers separated by '\' characters). Default: frame numbers absent. The frame numbers are required if the referenced image is a multiframe image.
  aetitle | the series retrieveAETitle. Default: value absent.
  filesetID | the series storageMediaFileSetID. Default: value absent.
  filesetUID | the series storageMediaFileSetUID. Default: value absent.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ checkSOPClass()

OFBool DVPSReferencedSeries_PList::checkSOPClass | ( | const char * | uid | ) |

checks whether all images referenced in this series use the passed SOP class UID.

Parameters

  uid | the SOP class UID to be checked

Returns
  result of the test

## ◆ clear()

void DVPSReferencedSeries_PList::clear | ( |  | ) |

reset the object to initial state.

After this call, the object is in the same state as after creation with the default constructor.

## ◆ clone()

DVPSReferencedSeries_PList* DVPSReferencedSeries_PList::clone | ( |  | ) |
| inline

clone method.

Returns
  a pointer to a new DVPSReferencedSeries_PList object containing a deep copy of this object.

## ◆ findImageReference()

DVPSReferencedImage* DVPSReferencedSeries_PList::findImageReference | ( | const char * | seriesUID,
|  | const char * | instanceUID
| ) |  |

find image reference in this list.

This method checks if an image reference with the given Series Instance UID and SOP instance UID exists in this ReferencedImageSequence.

Parameters

  seriesUID | the Series Instance UID of the searched image reference
  instanceUID | the SOP Instance UID of the searched image reference

Returns
  a pointer to the matching DVPSReferencedImage if found, NULL otherwise.

## ◆ findSeriesReference()

DVPSReferencedSeries* DVPSReferencedSeries_PList::findSeriesReference | ( | const char * | seriesUID | ) |

find series reference in this list.

This method checks if a series reference with the given Series Instance UID exists in this ReferencedSeriesSequence.

Parameters

  seriesUID | the Series Instance UID of the searched series reference

Returns
  a pointer to the matching DVPSReferencedSeries if found, NULL otherwise.

## ◆ getImageReference()

OFCondition DVPSReferencedSeries_PList::getImageReference | ( | size_t | idx,
|  | OFString & | seriesUID,
|  | OFString & | sopclassUID,
|  | OFString & | instanceUID,
|  | OFString & | frames,
|  | OFString & | aetitle,
|  | OFString & | filesetID,
|  | OFString & | filesetUID
| ) |  |

gets an image reference with the given index.

Parameters

  idx | index, must be < numberOfImageReferences().
  seriesUID | the Series Instance UID is returned in this string
  sopclassUID | the SOP Class UID is returned in this string
  instanceUID | the SOP Instance UID is returned in this string
  frames | the list of frames is returned in this string
  aetitle | the series retrieveAETitle is returned in this string
  filesetID | the series storageMediaFileSetID is returned in this string
  filesetUID | the series storageMediaFileSetUID is returned in this string

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ numberOfImageReferences()

size_t DVPSReferencedSeries_PList::numberOfImageReferences | ( |  | ) |

gets the number of image references in all series managed by this list.

Returns
  number of image references

## ◆ read()

OFCondition DVPSReferencedSeries_PList::read | ( | DcmItem & | dset | ) |

reads a list of series references (ReferencedSeriesSequence) from a DICOM dataset.

The DICOM elements of the image references item are copied from the dataset to this object. The completeness of all items (presence of all required elements, value multiplicity) is checked. If this method returns an error code, the object is in undefined state afterwards.

Parameters

  dset | the DICOM dataset from which the sequence is to be read

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ removeImageReference()

void DVPSReferencedSeries_PList::removeImageReference | ( | const char * | seriesUID,
|  | const char * | instanceUID
| ) |  |

removes image reference.

This method checks if an image reference with the given SOP instance UID exists in the series with the given Series Instance UID and deletes it.

Parameters

  seriesUID | the Series Instance UID of the image reference to be removed.
  instanceUID | the SOP instance UID of the image reference to be removed.

## ◆ removeSeriesReference()

void DVPSReferencedSeries_PList::removeSeriesReference | ( | const char * | seriesUID | ) |

removes series reference.

This method checks if an series reference with the given Series Instance UID exists in this ReferencedSeriesSequence and deletes it (including its image references).

Parameters

  seriesUID | the Series Instance UID of the series reference to be removed.

## ◆ write()

OFCondition DVPSReferencedSeries_PList::write | ( | DcmItem & | dset | ) |

writes the list of series references managed by this object to a DICOM dataset.

Copies of the DICOM element managed by this object are inserted into the DICOM dataset.

Parameters

  dset | the DICOM dataset to which the ReferencedSeriesSequence is written

Returns
  EC_Normal if successful, an error code otherwise.

The documentation for this class was generated from the following file:

- dcmpstat/include/dcmtk/dcmpstat/dvpsrsl.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1